/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.business.CalculateReportLayoutFactory
 *  com.deepexi.scd.calculate.domain.dto.CalculateEnterpriseUnitDTO
 *  com.deepexi.scd.calculate.domain.dto.CalculateReportDTO
 *  com.deepexi.scd.calculate.domain.dto.CalculateReportVO
 *  com.deepexi.scd.calculate.domain.query.CalculateReportQuery
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportChatApiVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutVO
 *  com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO
 *  com.deepexi.scd.calculate.service.CalculateReportService
 *  com.deepexi.scd.calculate.util.ExportWord
 *  com.deepexi.scd.common.util.BeanConverter
 *  com.deepexi.spa.commons.annotation.validate.Insert
 *  com.deepexi.spa.commons.annotation.validate.Update
 *  com.deepexi.spa.commons.data.PageBean
 *  com.deepexi.spa.commons.data.Payload
 *  io.swagger.annotations.Api
 *  io.swagger.annotations.ApiOperation
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.validation.annotation.Validated
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.deepexi.scd.calculate.controller;

import com.deepexi.scd.calculate.business.CalculateReportLayoutFactory;
import com.deepexi.scd.calculate.domain.dto.CalculateEnterpriseUnitDTO;
import com.deepexi.scd.calculate.domain.dto.CalculateReportDTO;
import com.deepexi.scd.calculate.domain.dto.CalculateReportVO;
import com.deepexi.scd.calculate.domain.query.CalculateReportQuery;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportChatApiVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutVO;
import com.deepexi.scd.calculate.domain.vo.report.ExportReportLayoutVO;
import com.deepexi.scd.calculate.service.CalculateReportService;
import com.deepexi.scd.calculate.util.ExportWord;
import com.deepexi.scd.common.util.BeanConverter;
import com.deepexi.spa.commons.annotation.validate.Insert;
import com.deepexi.spa.commons.annotation.validate.Update;
import com.deepexi.spa.commons.data.PageBean;
import com.deepexi.spa.commons.data.Payload;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.HashMap;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Api(tags={"核算报告"})
@RequestMapping(value={"/admin-api/v1/calculate/report"})
public class CalculateReportController {
    @Autowired
    private CalculateReportService calculateReportService;
    @Autowired
    private CalculateReportLayoutFactory calculateReportLayoutFactory;

    @ApiOperation(value="插入报告数据")
    @PostMapping
    public Payload<Long> insert(@Validated(value={Insert.class}) @RequestBody CalculateReportVO calculateReportVO) {
        return Payload.ok((Object)this.calculateReportService.insert(calculateReportVO));
    }

    @ApiOperation(value="生成报告（chat-api）")
    @PostMapping(value={"/chat"})
    public Payload<String> insertChat(@Validated(value={Insert.class}) @RequestBody CalculateReportChatApiVO calculateReportVO) {
        return Payload.ok((Object)this.calculateReportService.insertChatApi(calculateReportVO));
    }

    @ApiOperation(value="更新报告数据")
    @PutMapping(value={"/{calculateReportId}"})
    public Payload<Boolean> update(@Validated(value={Update.class}) @RequestBody CalculateReportDTO calculateReportDTO) {
        return Payload.ok((Object)this.calculateReportService.update(calculateReportDTO));
    }

    @ApiOperation(value="删除报告数据")
    @DeleteMapping(value={"/{calculateReportId}"})
    public Payload<Boolean> removeById(@PathVariable(value="calculateReportId") Long calculateReportId) {
        return Payload.ok((Object)this.calculateReportService.removeById(calculateReportId));
    }

    @ApiOperation(value="获取报告数据")
    @GetMapping(value={"/{calculateReportId}"})
    public Payload<CalculateReportDTO> getById(@PathVariable(value="calculateReportId") Long calculateReportId) {
        return Payload.ok((Object)this.calculateReportService.getById(calculateReportId));
    }

    @ApiOperation(value="获取报告分页列表")
    @GetMapping(value={"/paging"})
    public Payload<PageBean<CalculateReportDTO>> findPage(CalculateReportQuery query) {
        return Payload.ok((Object)this.calculateReportService.findPage(query));
    }

    @ApiOperation(value="获取报告的核算单元")
    @GetMapping(value={"/{calculateReportId}/enterpriseUnits"})
    public Payload<CalculateEnterpriseUnitDTO> getReportEnterpriseUnitList(@PathVariable(value="calculateReportId") Long calculateReportId) {
        return Payload.ok((Object)this.calculateReportService.getReportEnterpriseUnitList(calculateReportId));
    }

    @GetMapping(value={"/exportReport/{reportId}"})
    @ApiOperation(value="报表导出")
    public void exportReport(@PathVariable(value="reportId") Long reportId) throws Exception {
        this.calculateReportService.exportReport(reportId);
    }

    @GetMapping(value={"/exportReportVoucher/{reportId}"})
    @ApiOperation(value="导出报告凭证", nickname="exportReportVoucher")
    public void exportReportVoucher(@PathVariable(value="reportId") Long reportId, HttpServletResponse response) throws Exception {
        this.calculateReportService.exportReportVoucher(reportId, response);
    }

    @GetMapping(value={"/exportReportVO/{reportId}"})
    @ApiOperation(value="获取报表导出的数据")
    public Payload<ExportReportLayoutVO> exportReportVO(@PathVariable(value="reportId") Long reportId) {
        return Payload.ok((Object)this.calculateReportService.getExportReportLayoutVO(reportId));
    }

    @ApiOperation(value="获取报告详情")
    @GetMapping(value={"/loadLayout/{reportId}"})
    public Payload<CalculateReportLayoutVO> loadLayout(@PathVariable(value="reportId") Long reportId) {
        return Payload.ok((Object)this.calculateReportService.loadReportLayout(reportId));
    }

    @ApiOperation(value="获取核算单元报告详情")
    @GetMapping(value={"/loadLayout/{reportId}/{enterpriseUnitId}"})
    public Payload<CalculateLayoutVO> loadLayout(@PathVariable(value="reportId") Long reportId, @PathVariable(value="enterpriseUnitId") Long enterpriseUnitId) {
        return Payload.ok((Object)this.calculateReportService.loadFillLayout(reportId, enterpriseUnitId));
    }

    @GetMapping(value={"/test/{reportId}"})
    @ApiOperation(value="报表导出")
    public void test(@PathVariable(value="reportId") Long reportId) throws Exception {
        CalculateReportLayoutVO calculateReportLayoutVO = this.calculateReportLayoutFactory.loadLayout(reportId);
        ExportReportLayoutVO exportReportLayoutVO = (ExportReportLayoutVO)BeanConverter.to((Object)calculateReportLayoutVO, ExportReportLayoutVO.class);
        HashMap<String, Number> map = new HashMap<String, Number>();
        double num = 4.0;
        map.put("lastShowSize", (double)(exportReportLayoutVO.getTotalMap().size() - 1) % num);
        map.put("totalSize", (int)Math.ceil((double)(exportReportLayoutVO.getTotalMap().size() - 1) / num));
        map.put("layoutVO", (Number)exportReportLayoutVO);
        new ExportWord("utf-8").exportDoc("化工.doc", "chemicalIndustryTemplate.ftl", map);
    }
}

